 // File GrafoMA.h
#ifndef GRAFO_MA_H
#define GRAFO_MA_H
#include "Grafo.h"

class GrafoMA : public Grafo
{friend class IteratoreMA;
 public:
  GrafoMA(int);
  ~GrafoMA();
  GrafoMA(const GrafoMA&);
  GrafoMA& operator=(const GrafoMA&);
  int NumNodi();
  void MettiArco(int, int);
  void TogliArco(int, int);
  bool EsisteArco(int, int);
  Iteratore* Successori(int);
  Iteratore* Predecessori(int);
 private:
  int nodi;
  bool** matrice;
  static bool** Copia(bool**,int);
  static void Cancella(bool**,int);
};

class IteratoreMA : public Iteratore
{public:
  IteratoreMA(GrafoMA&,int,bool);
  bool HasNext();
  int Next();
  void Reset();
 private:
  int nxt;
  int start;
  GrafoMA* grafo;
  int nodo;
  bool succ_pred;
  bool mat(int,int);
};

#endif
